<app-loading *ngIf="isLoading"></app-loading>

<!-- update  -->
<nz-card class="header-form m-0">
  <div class="action-breadcrumb-float-right">
    <ng-container *ngTemplateOutlet="action"></ng-container>
  </div>
  <div nz-row [nzGutter]="[32, 32]" [formGroup]="proposeUnitForm">

    <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeCategory !== listProposeCategory.GROUP">
      <mb-select
      formControlName="formGroup"
      [mbDataSelects]="dataCommon.formGroupList"
      mbKeyLabel="name"
      mbKeyValue="id"
      mbLabelText="{{ 'development.proposed-unit.table.formGroup' | translate }}"
      mbPlaceholder="{{ 'development.proposed-unit.table.formGroup' | translate }}"
      [ngModelOptions]="{ standalone: true}"

    >
    </mb-select>
  </div>

  <div nz-col class="gutter-row rowInfoPropose" nzLg="6" *ngIf="proposeCategory === listProposeCategory.GROUP"></div>



  <ng-container *ngIf="proposeDTO?.relationType">
    <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeCategory === listProposeCategory.GROUP && proposeDTO?.handleCode">
    <span class="title-section">{{ 'development.proposed-unit.table.processingCode' | translate }}</span
      ><br />
      <label class="text-label">{{ proposeUnitForm.get('handleCode')?.value }}</label>
    </div>

    <div nz-col class="gutter-row" nzLg="6" *ngIf="!proposeDTO?.handleCode">
      <span class="title-section">{{ 'development.proposed-unit.table.proposeCode' | translate }}</span>
      <br />
      <label class="text-label">{{ proposeUnitForm.get('id')?.value }}</label>
    </div>

  </ng-container>
  <ng-container *ngIf="!proposeDTO?.relationType">
    <div nz-col class="gutter-row" nzLg="6" >
      <span class="title-section">{{ 'development.proposed-unit.table.proposeCode' | translate }}</span>
      <br />
      <label class="text-label">{{ proposeUnitForm.get('id')?.value }}</label>
    </div>
  </ng-container>



  <div nz-col class="gutter-row" nzLg="6">
    <span class="title-section">{{ 'development.proposed-unit.table.statusApprove' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('flowStatusName')?.value }}</label>
  </div>

  <div nz-col class="gutter-row" nzLg="6"
    *ngIf="proposeUnitForm.get('statusPublishName')?.value
    && proposeUnitForm?.get('formGroup')?.value !== constantsFormGroupCode.PV">
    <span class="title-section">{{ 'development.proposed-unit.table.statusPublish' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('statusPublishName')?.value }}</label>
  </div>

  <div nz-col class="gutter-row" nzLg="6" *ngIf="!proposeDTO?.relationType && proposeUnitForm.get('proposeUnitRequestName')?.value">
    <span class="title-section">{{ 'development.proposed-unit.table.sendProposeUnit' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('proposeUnitRequestName')?.value }}</label>
  </div>

  <div
    nz-col
    class="gutter-row"
    nzLg="6"
    *ngIf="screenCode !== screenCodeConst.HRDV && proposeDTO?.relationType && proposeCategory === listProposeCategory.GROUP"
  >
    <span class="title-section">{{ 'development.proposed-unit.table.contentsOfthePlan' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('optionNote')?.value }}</label>


    <mb-input-text
    *ngIf="isScreenHandle && flowStatusCode === flowCodeConstants.HANDLING6"
    formControlName="optionNote"
    mbPlaceholderText="{{ 'development.proposed-unit.table.contentsOfthePlan' | translate }}"

  ></mb-input-text>
  </div>

  <div
    nz-col
    class="gutter-row"
    nzLg="6"
    *ngIf="screenCode === screenCodeConst.PTNL && proposeUnitForm.get('withdrawNote')?.value"
  >
    <span class="title-section">{{ 'development.proposed-unit.table.noteWithdraw' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('withdrawNote')?.value }}</label>
  </div>



  </div>
</nz-card>

<ul nz-menu nzMode="horizontal" class="scroll__tab" *ngIf="!proposeUnitForm.get('relationType')?.value && (checkHidenHandleScreen() || hasProcess)">
  <li
    class="scroll__tab--title"
    *ngFor="let tab of scrollTabs"
    nz-menu-item
    (click)="scrollTo(tab)"
    [id]="'#' + tab.scrollTo"
  >
    <span>{{ tab.title | translate }}</span>
  </li>
</ul>

<!--Xử lý cá nhân đề xuất màn điều chuyển công tác(DCDD), thôi giữ chức vụ-->
<app-recommend-individual-propose
  *ngIf="proposeDTO?.personalCode &&
  (proposeUnitForm.get('formGroup')?.value === constantsFormGroupCode.TGCV
  || proposeUnitForm.get('formGroup')?.value === constantsFormGroupCode.DCDD)"
  [personalCode]="proposeDTO?.personalCode"
></app-recommend-individual-propose>

<app-propose-single
  *ngIf="isSingle && !proposeDTO?.personalCode"
  #proposeSingle
  [dataCommon]="dataCommon"
  (submitData)="save($event)"
  [dataForm]="proposeDTO?.proposeDetails[0]"
  [personalCode]="proposeDTO?.personalCode"
  [typeAction]="typeAction"
  [checkUnitRequest]="checkUnitRequest"
  [screenCode]="screenCode"
  [listInUnit]="listInUnit"
  [isScreenHandle]="isScreenHandle"
  [externalApproveParent]="externalApproveParent"
  [proposeUnitRequestName]="proposeUnitForm.get('proposeUnitRequestName')?.value"
  [showMinTime]="showMinTime"
  [showMaxTime]="showMaxTime"
  [flowStatusCode]="flowStatusCode"
  [formGroupCreate]="proposeUnitForm.get('formGroup')?.value"
  [proposeDetailId]="proposeDetailId"
  [proposeCategory]="proposeCategory"
  [proposeId]="proposeId"
  [proposeDTO]="proposeDTO"
  [proposeDecisionStatement]="proposeDecisionStatement"
></app-propose-single>
<app-propose-multiple
  *ngIf="isMultiple"
  #proposeMultiple
  [dataCommon]="dataCommon"
  (submitData)="save($event)"
  [dataForm]="proposeDTO"
  [typeAction]="typeAction"
  [screenCode]="screenCode"
  [flowStatusCode]="flowStatusCode"
  [statusPublishCode]="statusPublishCode"
  [proposeDetailId]="proposeDetailId"
  [proposeCategory]="proposeCategory"
  [proposeId]="proposeId"
  [proposeDecisionStatement]="proposeDecisionStatement"
  [proposeUnit]="proposeUnitForm.getRawValue()"
  [isScreenHandle]="isScreenHandle"
  (onLoading)="onLoading($event)"
  (checkFlowStatusElement)="getFlowStatusCodeElement($event)"
  [rolesOfCurrentUser]="rolesOfCurrentUser"
  [flowStatusCodeDisplay]="flowStatusCodeDisplay"
></app-propose-multiple>

<!-- Lịch sử -->
<nz-card *ngIf="proposeUnitApprove">
  <div nz-row>
    <div nz-col class="gutter-row" nzLg="2" (click)="expandLog()">
      <h3>{{ 'development.proposed-unit.section.proposeLogs' | translate }}</h3>
    </div>
    <div nz-col class="gutter-row" nzLg="1" (click)="expandLog()">
      <span class="iconLog">
        <em nz-icon nzType="{{ iconStatus }}"></em>
      </span>
    </div>
  </div>

  <mb-table-wrap *ngIf="isExpand" [mbTitle]="''" [extra]='false'>
    <mb-table [tableConfig]="tableConfig" [tableData]="proposeLogs"
              [heightTable]="heightTable"
              (changePageNum)='getLog($event)'
    >
    </mb-table>
  </mb-table-wrap>
</nz-card>

<ng-template #dateLog let-actionDate  = 'actionDate'>
  <em nz-icon nzType="calendar" nzTheme="outline" class="calendar" *ngIf="actionDate"></em>
  <span class="sentDate">{{ actionDate | date: 'dd/MM/yyyy HH:mm' }}</span>
</ng-template>


<!-- Lãnh đạo đơn vị -->
<nz-card class="idea" *ngIf="proposeUnitApprove">
  <h3>{{ 'development.proposed-unit.detail.idea' | translate }}</h3>
  <span class="title-section">{{ 'development.proposed-unit.detail.idea' | translate }}</span>
  <textarea
    nz-input
    placeholder="{{ 'development.proposed-unit.detail.idea' | translate }}"
    [(ngModel)]="note"
    name="note"
    [nzAutosize]="{ minRows: 4, maxRows: 6 }"
  ></textarea>
</nz-card>


<app-consultation-screen
  *ngIf="isSingle && (checkHidenHandleScreen() || hasProcess)"
  [proposeId]="proposeId"
  [screenCode]="screenCode"
  [proposeCategory]="proposeCategory"
  [dataForm]="proposeDTO"
  [typeAction]="typeAction"
  [proposeDetailId]="proposeDetailId"
  [dataCommon]="dataCommon"
  [flowStatusCode]="flowStatusCode"
  [statusPublishCode]="statusPublishCode"
  (onLoading)="onLoading($event)"
  (backScreenGroup)="back()"
  [stateUrl]="stateUrl"
  [elementPrintReport]="elementPrintReport"
  #consultationScreenComponent
></app-consultation-screen>



<nz-card class="idea" *ngIf="checkBtnWithdrawPTNL() && typeAction === screenType.detail">
  <div nz-row [nzGutter]="[40, 32]">
    <div nz-col class="gutter-row" nzLg="8">
      <span class="title-section">{{ 'development.proposed-unit.detail.menu.approrvedProposals' | translate }}</span>
      <div class="withdraw__handle" *ngIf="checkWithdrawTypebtn">
        <nz-radio-group nzDisabled="true" [ngModel]="checkWithdrawType">
          <label class="propose-radio"  nz-radio [nzValue]="0">{{ 'development.proposed-unit.detail.menu.cancelProposal' | translate }}</label>
          <label class="propose-radio" nz-radio [nzValue]="1">{{ 'development.proposed-unit.detail.menu.editProposal' | translate }}</label>
        </nz-radio-group>
      </div>
      <div class="withdraw__handle" *ngIf="!checkWithdrawTypebtn"><span>{{ 'development.proposed-unit.detail.menu.rejectWithdrawProposals' | translate }}</span></div>
    </div>
    <div nz-col class="gutter-row" nzLg="24">
      <mb-input-text
        [mbIsTextAre]='true'
        [mbConfig]="{ rows: 4, autoSize: true }"
        [mbDisable]="true"
        [ngModel]="proposeDTO?.withdrawReason"
        mbLabelText="{{ 'development.proposed-unit.detail.menu.reason' | translate }}"
        mbPlaceholderText="{{ 'development.proposed-unit.detail.menu.reason' | translate }}"
      ></mb-input-text>
    </div>
    <div nz-col class="gutter-row" nzLg="24">
      <mb-input-text
        [mbIsTextAre]='true'
        [mbConfig]="{ rows: 4, autoSize: true }"
        [(ngModel)]="comment"
        name="comment"
        mbLabelText="{{ 'development.proposed-unit.detail.idea' | translate }}"
        mbPlaceholderText="{{ 'development.proposed-unit.detail.idea' | translate }}"
      ></mb-input-text>
    </div>
  </div>
  <div nz-row *ngIf="!externalApprove" [nzGutter]="[40, 32]" class="withdraw__handle">
      <div nz-col class="gutter-row" nzLg="6">
        <mb-input-text
          [ngModel]="proposestatementNumber"
          [mbDisable]="true"
          mbLabelText="{{ 'development.proposed-unit.reportCard.stateNumber' | translate }}"
          mbPlaceholderText="{{ 'development.proposed-unit.reportCard.stateNumber' | translate }}"
        >
        </mb-input-text>
      </div>
      <div nz-col class="gutter-row" nzLg="6">
        <mb-date-picker
          [ngModel]="proposesubmissionDate"
          [mbDisabled]="true"
          mbFormat="dd/MM/yyyy"
          mbPlaceholderText="dd/mm/yyyy"
          mbLabelText="{{ 'development.proposed-unit.reportCard.submissionDate' | translate }}"
        >
        </mb-date-picker>
      </div>
      <div nz-col class="gutter-row" nzLg="6">
          <span class="title-section">{{ 'development.proposed-unit.reportCard.stateOfLeader' | translate }}</span
          ><br/>
        <span
          class="file"
          (click)="downloadFile()"
        >{{ proposedocName }}</span
        >
      </div>
  </div>
</nz-card>

<nz-page-header id="tab8" class="site-page-header">
  <!-- <nz-page-header-extra>
    <ng-container *ngTemplateOutlet="action"></ng-container>
  </nz-page-header-extra> -->
</nz-page-header>

<ng-template #action>
  <!-- phê duyệt của KSPTNL ở màn duyệt, màn chi tiết chỉ view -->
  <ng-container *ngIf="checkIdeaApproveKSPTNL()">
    <mb-button mbButtonAvailableStyle="PRIMARY" mbButtonSize='LARGE'
      mbButtonText="{{ 'development.proposed-unit.button.agreeLeader' | translate }}"
      (click)="approveKSPTNL()"
      *ngIf="proposeCategory === listProposeCategory.GROUP">
    </mb-button>

    <mb-button *ngIf="proposeUnitForm.get('relationType')?.value" mbButtonAvailableStyle="BORDER" mbButtonSize='LARGE'
        mbButtonText="{{ 'development.proposed-unit.button.otherIdea' | translate }}"
        (click)="otherIdeaKSPTNL()">
    </mb-button>


    <mb-button *ngIf="!proposeUnitForm.get('relationType')?.value && proposeDTO?.proposeDetails[0]?.groupByKSPTNL" mbButtonAvailableStyle="BORDER" mbButtonSize='LARGE'
      mbButtonText="{{ 'development.proposed-unit.button.otherIdea' | translate }}"
      (click)="otherIdeaElementKSPTNL()">
    </mb-button>
  </ng-container>


  <!--  Duyệt rút đề xuất thành phần-->
  <ng-container *ngIf="checkBtnWithdrawPTNL() && typeAction === screenType.detail">
    <mb-button
      mbButtonAvailableStyle="PRIMARY"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.agreeLeader' | translate }}"
      (click)="agreeWithdrawProposalDetail( 1)">
    </mb-button>

    <mb-button
      mbButtonAvailableStyle="DANGER"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.rejectLeader' | translate }}"
      (click)="agreeWithdrawProposalDetail( 2)">
    </mb-button>
  </ng-container>

  <!-- Button xử lý màn detail(mà xl)) ELEMENT -->
  <ng-container *ngIf="!proposeUnitForm.get('relationType')?.value; else nhieuthanhphan">
    <!-- Mà xử lý -->
    <!-- Màn chi tiết PTNL -->
    <ng-container
      *ngIf="screenCode === screenCodeConst.PTNL && typeAction !== screenType.detail && checkSaveSendPropose()"
    >
      <mb-button mbButtonAvailableStyle="PRIMARY" mbButtonSize='LARGE'
          mbButtonText="{{ 'development.proposed-unit.button.save' | translate }}"
          (click)="saveHandle()">
      </mb-button>
      <mb-button mbButtonAvailableStyle="BORDER" mbButtonSize='LARGE'
          mbButtonText="{{ 'development.proposed-unit.button.sendApprove' | translate }}"
          (click)="processingPTNL()"
          *ngIf="checkBTNprocessingPTNL() && !stateUrl?.state?.backUrl && proposeDTO?.handleCode">
      </mb-button>
    </ng-container>

    <ng-container *ngIf="screenCode === screenCodeConst.PTNL && typeAction === screenType.detail">

      <!-- trả lại đề xuất -->
      <mb-button mbButtonAvailableStyle="PRIMARY"
                 mbButtonText="{{ 'development.proposed-unit.button.returnPropose' | translate }}"
                 *ngIf="checkReturnProposeButton()"
                 (click)="showModalReturnPropose()"
      >
      </mb-button>
    </ng-container>
  </ng-container>

  <!-- xóa -->
  <mb-button mbButtonAvailableStyle="DANGER" mbButtonSize='LARGE'
    mbButtonText="{{ 'development.proposed-unit.button.delete' | translate }}"
    *ngIf="isDeletePTNL"
    (click)="deleteHandle()">
  </mb-button>

  <!-- xử lý -->
  <mb-button mbButtonAvailableStyle="BORDER" mbButtonSize='LARGE'
    mbButtonText="{{ 'development.proposed-unit.button.handle' | translate }}"
    *ngIf="checkHandleButton()"
    (click)="handle()">
  </mb-button>
<!-- "-->
  <ng-template #nhieuthanhphan>
    <ng-container *ngIf="screenCode === screenCodeConst.PTNL && (checkSaveSendPropose() && typeAction !== screenType.detail) || (typeAction === screenType.detail && checkFlowStatusElement)"
    >
      <mb-button mbButtonAvailableStyle="PRIMARY" mbButtonSize='LARGE'
        mbButtonText="{{ 'development.proposed-unit.button.save' | translate }}"
        (click)="saveHandle()">
      </mb-button>
      <mb-button mbButtonAvailableStyle="BORDER" mbButtonSize='LARGE'
        mbButtonText="{{ 'development.proposed-unit.button.sendApprove' | translate }}"
        (click)="sendApproveGroupPTNL()"
        *ngIf="checkBTNprocessingPTNL() && proposeDTO?.handleCode && flowStatusCode !== flowCodeConstants.KSDongY">
      </mb-button>
    </ng-container>

  </ng-template>

  <!-- quay lại -->
  <mb-button mbButtonAvailableStyle="BORDER" mbButtonSize='LARGE'
    mbButtonText="{{ 'development.proposed-unit.button.back' | translate }}"
    *ngIf="stateUrl"
    (click)="back()">
  </mb-button>
</ng-template>
<ng-template #popUpError>
  <div *ngIf="messageListError" class="message_error">
    <span>{{ messageListError }}</span>
  </div>
</ng-template>
